package Parkhaus;

/**
 * 
 * @author Lorenz Schauer
 * 
 * Implementierung der Parkhausaufgabe zur Synchronisation von Threads mittels Monitoren
 *
 */
public class Parkhaus {
	
	private final int MAX = 5;
	private int anzahl_autos;
	
	public synchronized void einfahren(){
		
		while(anzahl_autos>=MAX){
			try {
				wait();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		this.rampeFahren("ins Prakhaus");
		System.out.println(Thread.currentThread().getName()+" parkt im Parkhaus.");
		this.anzahl_autos++;
		System.out.println(this.anzahl_autos+" Autos im Parkhaus");
		
	}
	
	public synchronized void ausfahren(){
		
		this.rampeFahren("aus dem Parkhaus");
		this.anzahl_autos--;
		notifyAll();
	}
	
	private synchronized void rampeFahren(String richtung){
		System.out.println(Thread.currentThread().getName()+" faehrt "+richtung);
	}
	
	
	public static void main(String[] args) {

		Parkhaus p = new Parkhaus();
		
		for(int i=0;i<10;i++){
			String name = "Auto_"+i;
			new Auto(name,p).start();
		}

	}

}
