package Parkhaus;

/**
 * 
 * @author Lorenz Schauer
 * 
 * Implementierung der Parkhausaufgabe zur Synchronisation von Threads mittels Semaphoren
 * Man Beachte: Die Klasse Semaphore ist wieder mit einem Monitor realisiert.
 *
 */
public class ParkhausSema {

	private final int MAX=5;
	private int anzahl_autos;
	
	private Semaphore binSema;
	private Semaphore zaehlSema;
	
	public ParkhausSema(){
		this.anzahl_autos=0;
		this.binSema = new Semaphore(1); // Binaersemaphore zum schuetzen des wechselseitigen Ausschlusses auf die Rampe
		this.zaehlSema = new Semaphore(MAX);  // Zaehlsemaphore zum pruefen der Plaetze
	}
	
	public void einfahren() throws InterruptedException{
		
		zaehlSema.down(); // Erst pruefen, ob Platz frei ist...
		binSema.down();  // Dann Zugriff auf die Rampe
		this.rampeFahren("ins Parkhaus");
		binSema.up();  // Rampe verlassen
		this.anzahl_autos++; // Anzahl erhhen
		System.out.println(Thread.currentThread().getName()+" parkt im Parkhaus.");
		System.out.println(this.anzahl_autos+" Autos im Parkhaus");
	}
	
	public void ausfahren() throws InterruptedException{
		binSema.down(); // Zugriff auf die Rampe
		this.rampeFahren("aus dem Parkhaus");
		binSema.up();
		this.anzahl_autos--; // Rausfahren und Anzahl verringern
		zaehlSema.up();
	}
	
	private void rampeFahren(String richtung){
		System.out.println(Thread.currentThread().getName()+" faehrt "+richtung);
	}

	
	public static void main(String[] args) {

		ParkhausSema p = new ParkhausSema();
		
		for(int i=0;i<10;i++){
			String name = "Auto_"+i;
			new AutoSema(name,p).start();
		}

	}
}
