package synch;

import java.util.Random;

public class Speicher {
	
	private double[] speicher;
	private int pointer;
	private int size;
	
	private Random r = new Random();
	
	public Speicher(double[] speicher){
		this.speicher = speicher;
		this.size = speicher.length;
		this.pointer=0;
	}
	
	public synchronized void produce() throws InterruptedException {
		
		while(pointer>=size) this.wait();
		
		//modify monitor state
		double element = r.nextDouble();
		speicher[pointer]= element;
		System.out.println("Producer produziert: "+element+" und legt es auf Position "+pointer);
		pointer++;
		
		notify();
	}
	
	public synchronized void consume() throws InterruptedException{
		
		while(pointer<=0) wait();
		
		//modify monitor state
		pointer--;
		System.out.println("Consumer konsumiert element: "+speicher[pointer]+" an Position "+pointer);
		
		notify();
	}


	public static void main(String[] args) {
		
		double[] speicher = new double[5];
		
		Speicher mein_speicher = new Speicher(speicher);
		
		Consumer c = new Consumer(mein_speicher);
		Producer p = new Producer(mein_speicher);
		
		c.start();
		p.start();
		
	}

}
