package synch2;

public class Consumer extends Thread{

	private Speicher s;
	
	public Consumer(Speicher s){	
		this.s = s;
	}
	
	public void consume() throws InterruptedException{
		
		// Beachte hierbei: Den Monitor besitzt das Speicher-Objekt. Nicht der Verbraucher selbst! 
		// Daher muss innerhalb der Objektmethode vom Verbraucher das Lock des Speicherobjekts angefordert werden.
		// Dies geschieht mit synchronized 
		synchronized(this.s){	
			
			// Auch muss sich der Thread in die Warteschlange des Speicherobjekts einreihen, daher s.wait()
			while(s.getPositon()<=0) s.wait();
			s.remove(s.getPositon());
			System.out.println("Consumer konsumiert element: "+s.getElement(s.getPositon())+" an Position "+s.getPositon());
			
			// Genauso muss der Weck-Ruf auf das Sepicherobjekt erfolgen, daher s.notify().
			s.notify();
		}	
	}
	
	@Override
	public void run() {
		while(true){
			try {
				this.consume();
				//sleep(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
}
